﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;

namespace _111860
{
    public partial class Form1 : Form
    {
        List<Image> images = new List<Image>();
        Infragistics.Win.Appearance HottracRowCellApp = new Infragistics.Win.Appearance();
        Infragistics.Win.Appearance defCellApp = new Infragistics.Win.Appearance();
        
        
        Infragistics.Win.Appearance HottracRowApp = new Infragistics.Win.Appearance();
        Infragistics.Win.Appearance defRowApp = new Infragistics.Win.Appearance();
        public Form1()
        {
            InitializeComponent();  
            
            images.Add(Image.FromFile("..\\..\\Images\\AudioVideo.jpg"));
            images.Add(Image.FromFile("..\\..\\Images\\Edit.jpg"));
            images.Add(Image.FromFile("..\\..\\Images\\Help.jpg"));
            images.Add(Image.FromFile("..\\..\\Images\\Wait.jpg"));

            defCellApp.AlphaLevel = 255;
            defCellApp.Image = images[1];
            defCellApp.ImageAlpha = Alpha.UseAlphaLevel;
            defCellApp.BackColorAlpha = Alpha.UseAlphaLevel;

            HottracRowCellApp.AlphaLevel = 255;
            HottracRowCellApp.Image = images[2];
            HottracRowCellApp.ImageAlpha = Alpha.UseAlphaLevel;
            HottracRowCellApp.BackColorAlpha = Alpha.Opaque;

            defRowApp.AlphaLevel = 80;
            defRowApp.ImageAlpha = Alpha.UseAlphaLevel;
            defRowApp.BackColorAlpha = Alpha.UseAlphaLevel;

            HottracRowApp.AlphaLevel = 255;
            HottracRowApp.ImageAlpha = Alpha.UseAlphaLevel;
            HottracRowApp.BackColorAlpha = Alpha.UseAlphaLevel;

        }

        private void Form1_Load(object sender, EventArgs e)
        {

            DataSet ds = new DataSet();
            DataTable root = new DataTable("A");
            root.Columns.Add("id", typeof(int)).AutoIncrement = true;
            root.Columns.Add("select", typeof(bool)).DefaultValue = false;
            root.Columns.Add("column", typeof(string)).Expression = "'A' + id";

            DataTable child1 = new DataTable("B");
            child1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            child1.Columns.Add("select", typeof(bool)).DefaultValue = false;
            child1.Columns.Add("pid", typeof(int));
            child1.Columns.Add("column", typeof(string)).Expression = "'B' + id";
           
            DataTable child2 = new DataTable("C");
            child2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            child2.Columns.Add("select", typeof(bool)).DefaultValue = false;
            child2.Columns.Add("pid", typeof(int));
            child2.Columns.Add("column", typeof(string)).Expression = "'C'+ id";
            child2.Columns.Add("sp1", typeof(string)).Expression = "'SP1' +id";
            child2.Columns.Add("sp2", typeof(string)).Expression = "'SP2'+id";

            ds.Tables.AddRange(new DataTable[] { root, child1, child2 });
            ds.Relations.Add(root.Columns["id"], child1.Columns["pid"]);
            ds.Relations.Add(child1.Columns["id"], child2.Columns["pid"]);


            for (int i = 0; i < 3; i++)
            {
                DataRow rootRow = root.Rows.Add();
                for (int j = 0; j < 3; j++)
                {
                    DataRow child1Row = child1.Rows.Add(null,null, rootRow["id"]);
                    for (int k = 0; k < 2; k++)
                    {
                        child2.Rows.Add(null,null, child1Row["id"]);
                    }
                }
            }

            ultraGrid1.DrawFilter = new CheckBoxOnMouseHover();
            ultraGrid1.DataSource = ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            foreach (UltraGridBand b in e.Layout.Bands)
            {
                b.ColHeadersVisible = false;
                b.Columns["id"].Hidden = true;
                UltraGridColumn col = b.Columns.Add("State");
                col.DataType = typeof(Image);
                col.Header.VisiblePosition = 0;
            }
                
            //e.Layout.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;

            UltraGridOverride ov = e.Layout.Override;
            //ov.RowAppearance.AlphaLevel = 90;
            //ov.RowAppearance.BackColorAlpha = Alpha.UseAlphaLevel;
            ////ov.RowAppearance.Image = images[1];

            //ov.HotTrackRowAppearance.AlphaLevel = 255;
            //ov.HotTrackRowAppearance.BackColorAlpha = Alpha.UseAlphaLevel;
            ////ov.HotTrackRowAppearance.Image = images[2];     

            ov.RowAlternateAppearance.BackColor = Color.AntiqueWhite;

            //ov.BorderStyleRow = UIElementBorderStyle.None;
            ov.BorderStyleCell = UIElementBorderStyle.None;



            
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.Band.Index == 2)
            {
                if (e.Row.Band.Columns.Exists("sp1"))
                    e.Row.Cells["sp1"].Hidden = true;
                if (e.Row.Band.Columns.Exists("sp2"))
                    e.Row.Cells["sp2"].Hidden = true;
            }

            if (!e.ReInitialize)
            {
                e.Row.Cells["State"].Value = images[0];
                e.Row.Appearance = defRowApp;
                e.Row.Cells["column"].Appearance = defCellApp;
            }

            
        }

        private void ultraGrid1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
           RowUIElement row =  e.Element.GetAncestor(typeof(RowUIElement)) as RowUIElement;
            if(meetsCriteria(row))
            {
                row.Row.Cells["sp1"].Hidden = false;
                row.Row.Cells["sp2"].Hidden = false;
            }

            if (row != null)
            {
                row.Row.Cells["column"].Appearance = HottracRowCellApp;
                row.Row.Appearance = HottracRowApp;
            }
               
        }

        private bool meetsCriteria(RowUIElement row)
        {
            if (row == null)
                return false;
            if (row.Row.Band.Columns.Exists("sp1") && row.Row.Band.Columns.Exists("sp2"))
                return row.Row.Index == 0;
            else
                return false;
        }

        private void ultraGrid1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            RowUIElement row = e.Element.GetAncestor(typeof(RowUIElement)) as RowUIElement;
            if (meetsCriteria(row))
            {
                row.Row.Cells["sp1"].Hidden = true;
                row.Row.Cells["sp2"].Hidden = true;
            }

            if (row != null)
            {
                row.Row.Cells["column"].Appearance = defCellApp;
                row.Row.Appearance = defRowApp;
            }
        }

        private void ultraGrid1_ClickCell(object sender, ClickCellEventArgs e)
        {
            if (e.Cell.Column.Key == "State")
            {
                Image img = (Image)e.Cell.Value;

                e.Cell.Value = images[(images.IndexOf(img) + 1) % images.Count];
            }
        }


    }
}
